aboutsummaryrefslogtreecommitdiff
path: root/contrib/cpt-orphans
diff options
context:
space:
mode:
Diffstat (limited to 'contrib/cpt-orphans')
-rwxr-xr-xcontrib/cpt-orphans27
1 files changed, 27 insertions, 0 deletions
diff --git a/contrib/cpt-orphans b/contrib/cpt-orphans
new file mode 100755
index 0000000..f42c49e
--- /dev/null
+++ b/contrib/cpt-orphans
@@ -0,0 +1,27 @@
+#!/bin/sh -e
+# Print orphaned packages.
+
+trap 'rm -f $CPT_TMPDIR/packages-$$' EXIT
+
+cd "$CPT_ROOT/var/db/cpt/installed"
+
+# Get base packages.
+[ -f "$CPT_ROOT/etc/cpt-base" ] && while read -r pkg _; do
+ case "$pkg" in ''|\#*) continue; esac
+ base=" $pkg $base"
+done < "$CPT_ROOT/etc/cpt-base"
+
+# Make a list of packages, but remove the base.
+for pkg in *; do
+ case "$base" in *" $pkg "*) continue; esac
+ printf '%s\n' "$pkg"
+done > "${CPT_TMPDIR:=/tmp}/packages-$$"
+
+# List dependencies.
+cat ./*/depends |
+
+# Remove make dependencies.
+while read -r dep make; do [ "$make" ] || printf '%s\n' "$dep"; done | sort -u |
+
+# Remove dependencies from the list and print.
+comm -23 "$CPT_TMPDIR/packages-$$" -